<?php
/**
 * @package Akismet
 */
/*
Plugin Name: HR Office Vacancy Listing
Plugin URI: https://hroffice.eu/
Description: HROffice Vacancy Listing allows you to Create shortcode for Vacancy listing
Version: 1.0.0
Author: HR Office
Author URI: https://nowonlineutrecht.atlassian.net/wiki/spaces/HRAD/overview
License: GPLv2 or later
Text Domain: hr_office_vacancy_domain
Domain Path: /languages/
*/


// Load plugin translation.
function hr_office_vacancy_listing_load_textdomain() {
    load_plugin_textdomain( 'hr_office_vacancy_domain', false, basename( dirname( __FILE__ ) ) . '/languages/' );
}
add_action( 'init', 'hr_office_vacancy_listing_load_textdomain' );

//Plugin Post Type
include(plugin_dir_path( __FILE__ ) . 'admin/plugin-post-type.php');
//Plugin Meta box
include(plugin_dir_path( __FILE__ ) . 'admin/plugin-post-metabox.php');
//Plugin API ajax call
include(plugin_dir_path( __FILE__ ) . 'admin/plugin-api-ajax-call.php');
//Listing Shortcode
include(plugin_dir_path( __FILE__ ) . 'front/plugin-listing-shortcode.php');
//Listing ajax data
include(plugin_dir_path( __FILE__ ) . 'front/plugin-listing-ajax-data.php');
//Apply Form ajax data
include(plugin_dir_path( __FILE__ ) . 'front/plugin-apply-form-ajax-data.php');
//License Key admin page
include(plugin_dir_path( __FILE__ ) . 'admin/plugin-license-key-settings.php');
//Cron License check admin page
include(plugin_dir_path( __FILE__ ) . 'admin/plugin-cron-license-check.php');

// Add JavaScripts in plugin
function hr_office_vacancy_enqueue_script() {   
    wp_enqueue_style( 'hr_office_vacancy_style',  plugin_dir_url( __FILE__ ). 'assets/css/hr_office_vacancy_style.css');
    wp_enqueue_script( 'hr_office_vacancy_js', plugin_dir_url( __FILE__ ) . 'assets/js/hr_office_vacancy_js.js', array('jquery'), '1.0', true );
}
add_action('wp_enqueue_scripts', 'hr_office_vacancy_enqueue_script');

function hr_office_vacancy_enqueue_script_admin() { 
    wp_enqueue_style( 'wp-color-picker' );
    wp_enqueue_style( 'hr_office_vacancy_admin_style',  plugin_dir_url( __FILE__ ). 'assets/css/hr_office_vacancy_admin_style.css');
    
    wp_enqueue_script( 'hr_office_vacancy_admin_js', plugin_dir_url( __FILE__ ) . 'assets/js/hr_office_vacancy_admin_js.js', array('jquery'), '1.0', true );
    
    $localize_script_array = array(
      'ajaxurl' => admin_url('admin-ajax.php'),
      'api_empty_msg' => __( 'Please Enter your API credentials', 'hr_office_vacancy_domain' ),
      'api_working_msg' => __( 'Working', 'hr_office_vacancy_domain' ), 
      'api_notworking_msg' => __( 'Not Working', 'hr_office_vacancy_domain' ),       
    );
    wp_localize_script( 'hr_office_vacancy_admin_js', 'frontend_ajax_object', $localize_script_array );
    wp_enqueue_script( 'meta-box-color-js', plugin_dir_url( __FILE__ ) . 'assets/js/meta-box-color.js', array('wp-color-picker'), '1.0', true );  
}
add_action('admin_enqueue_scripts', 'hr_office_vacancy_enqueue_script_admin');

//Plugin Settings Link
function hr_office_vacancy_listing_settings_link($links) { 
  $status  = get_option( 'hr_office_vacancy_plugin_license_status' );
  
  if($status == 'valid'){
    $settings_link = '<a href="edit.php?post_type=hroffice_vacn_shortc">Settings</a>';
  }else{
    $settings_link = '<a href="edit.php?post_type=hroffice_vacn_shortc&page=license_configuration">Settings</a>';
  }
   
  array_unshift($links, $settings_link); 
  return $links; 
}
$pluginfile = plugin_basename(__FILE__); 
add_filter("plugin_action_links_$pluginfile", 'hr_office_vacancy_listing_settings_link' );